"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var dikeClients_1 = require("../dikeClients");
var rxjs_1 = require("rxjs");
var electron_1 = require("electron");
var Utils_1 = require("../Utils");
var path = require("path");
var i18n = require('i18n');
var os = require('os');
var GetConfigurationChannel = /** @class */ (function () {
    function GetConfigurationChannel() {
        this._ev = new rxjs_1.Subject();
        this.events = this._ev.asObservable();
    }
    GetConfigurationChannel.prototype.handleRequest = function (body) {
        var _this = this;
        var instance = dikeClients_1.DikeClients.getInstance();
        return instance.getConfiguration().then(function (value) {
            if (electron_1.app.getLoginItemSettings().openAtLogin != !value.user.DisableAutostart) {
                var appName = path.parse(process.execPath).name;
                if (['win32'].includes(os.platform()) && Utils_1.isSquirrel()) {
                    var appFolder = path.dirname(process.execPath);
                    var updateExe = path.resolve(appFolder, '..', 'Update.exe');
                    var exeName = path.basename(process.execPath);
                    electron_1.app.setLoginItemSettings({
                        openAtLogin: !value.user.DisableAutostart,
                        openAsHidden: true,
                        path: updateExe,
                        args: [
                            '--processStart', "\"" + exeName + "\"",
                            '--process-start-args', "\"--start-tray\""
                        ]
                    });
                }
                else {
                    electron_1.app.setLoginItemSettings({
                        openAtLogin: !value.user.DisableAutostart,
                        openAsHidden: true,
                        args: ['--start-tray'],
                    });
                }
            }
            // updates electron locale
            i18n.setLocale(value.gui.language);
            _this._ev.next(value);
            return value;
        });
    };
    return GetConfigurationChannel;
}());
exports.GetConfigurationChannel = GetConfigurationChannel;
var SetConfigurationChannel = /** @class */ (function () {
    function SetConfigurationChannel() {
    }
    SetConfigurationChannel.prototype.handleRequest = function (body) {
        var instance = dikeClients_1.DikeClients.getInstance();
        return instance.setConfiguration(body.prop, body.json);
    };
    return SetConfigurationChannel;
}());
exports.SetConfigurationChannel = SetConfigurationChannel;
var CheckConnection = /** @class */ (function () {
    function CheckConnection() {
    }
    CheckConnection.prototype.handleRequest = function () {
        var instance = dikeClients_1.DikeClients.getInstance();
        return instance.checkConnection();
    };
    return CheckConnection;
}());
exports.CheckConnection = CheckConnection;
//# sourceMappingURL=ConfigurationHandlers.js.map