"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var electron_1 = require("electron");
var dikeClients_1 = require("../dikeClients");
var logger_1 = require("../logger");
var EIDG_CALLBACK_URL = 'diker://dike/OAUTH_AUTHORIZE_EID';
var logger = logger_1.provideLogger('SpidAuthenticationHandlers');
var StartSpidAuthenticationChannel = /** @class */ (function () {
    function StartSpidAuthenticationChannel() {
    }
    StartSpidAuthenticationChannel.prototype.handleRequest = function (body) {
        logger.info("Starting login flow");
        var instance = dikeClients_1.DikeClients.getInstance();
        return instance.getEIDGUrl(EIDG_CALLBACK_URL).then(function (EIDGUrl) {
            logger.info("Opening browser o '" + EIDGUrl + "'");
            var url1 = new URL(EIDGUrl.url);
            return electron_1.shell.openExternal(url1.toString()).then(function () { return ({}); });
        });
    };
    return StartSpidAuthenticationChannel;
}());
exports.StartSpidAuthenticationChannel = StartSpidAuthenticationChannel;
var CheckSpidCoupon = /** @class */ (function () {
    function CheckSpidCoupon() {
    }
    CheckSpidCoupon.prototype.handleRequest = function (body) {
        var instance = dikeClients_1.DikeClients.getInstance();
        return instance.getEIDGCheckCoupon(body.coupon);
    };
    return CheckSpidCoupon;
}());
exports.CheckSpidCoupon = CheckSpidCoupon;
var SpidEmissionOneShot = /** @class */ (function () {
    function SpidEmissionOneShot() {
    }
    SpidEmissionOneShot.prototype.handleRequest = function (body) {
        var instance = dikeClients_1.DikeClients.getInstance();
        return instance.getEIDGOneshotEmission(body.authorize, body.clausole, body.numFirme, body.email, body.coupon, body.identifier);
    };
    return SpidEmissionOneShot;
}());
exports.SpidEmissionOneShot = SpidEmissionOneShot;
var SpidOneShotCount = /** @class */ (function () {
    function SpidOneShotCount() {
    }
    SpidOneShotCount.prototype.handleRequest = function (body) {
        var instance = dikeClients_1.DikeClients.getInstance();
        return instance.getEIDGOneshotCount(body.identifier);
    };
    return SpidOneShotCount;
}());
exports.SpidOneShotCount = SpidOneShotCount;
//# sourceMappingURL=SpidAuthenticationHandlers.js.map